
#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include <dos.h>

#include "main.h"


BOOLEAN LoadLibraries()
{
	hLib301 = LoadLibrary ("LL_USB2k.dll");
    if(!hLib301) return FALSE;
    return TRUE;
}

BOOLEAN InitLibFuncs()
{  
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib301, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetPolledModeChan = (P_DLL_EX_SET_CHAN)GetProcAddress(hLib301, "EX_SetPolledModeChan");
	if(!EX_SetPolledModeChan) return FALSE;
	EX_SetScanType = (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLib301, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_Run = (P_DLL_EX_RUN)GetProcAddress(hLib301, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_Stop = (P_DLL_EX_STOP)GetProcAddress(hLib301, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete = (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib301, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;
	EX_SetScanEndEvent = (P_DLL_EX_SET_SCAN_EVENT)GetProcAddress(hLib301, "EX_SetScanEndEvent");
	if(!EX_SetScanEndEvent) return FALSE;
	EX_SetRunEndBeepOptions = (P_DLL_EX_SET_RUN_END_BEEP)GetProcAddress(hLib301, "EX_SetRunEndBeepOptions");
	if(!EX_SetRunEndBeepOptions) return FALSE;
	EX_CheckScanStatus = (P_DLL_EX_CHECK_SCAN_STATUS)GetProcAddress(hLib301, "EX_CheckScanStatus");
	if(!EX_CheckScanStatus) return FALSE;
    return TRUE;
}

int __cdecl main()
{
	BOOLEAN fRetVal = FALSE; BOOLEAN fRunning = FALSE; BOOLEAN fRedraw = FALSE; 
	UINT uiScanTimeout = 0; BYTE bDigitalEvent=0;

	if(!LoadLibraries()){ printf("Failed to load libraries"); getch(); return 0;}
	printf("Success loading libraries\n");

	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nConnecting -  please wait. . .");

	fRetVal = EX_Connect(&usDevID);
	if(!(fRetVal | usDevID))
	{ printf("Failed  EX_Connect()"); getch(); return 0; }

	char cUserInputVal = NULL; char szOutVal[32], szTempBuff[32]; int iKeyChar = 0; 
	sprintf(szOutVal, "");

	while(true)
	{
		setMainScreen();

		fRedraw = FALSE;

		while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 27) && (!fRedraw))
		{
			sprintf(szOutVal, ""); 
			cUserInputVal = (char)getch();
			switch(cUserInputVal)
			{
				case 'Q': case 'q': case 27:
					printf("\nDisconnecting and exiting, please wait ....\n"); break;
				case 'R': case 'r':
					fRedraw = TRUE; system("cls"); break;
				case 'C': case 'c':
					printf("\nenter channel: ");
					while(TRUE)
					{
						iKeyChar = getche(); if(iKeyChar == 13) break;
						if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57))) 
						{
							setMainScreen(); 
							 if( (strlen(szOutVal) > 0) && (iKeyChar == 8)) szOutVal[strlen(szOutVal)-1] = 0; 
							printf("\nenter channel: %s", szOutVal);
							continue;
						}
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff); if(strlen(szOutVal) == 1) break;
					}
					
					if(((UINT)(atoi(szOutVal))) > 7)
					{ printf("\nvalue entered greater than 7. New value: 7"); sprintf(szOutVal, "7"); }
					
					if(!EX_SetPolledModeChan(usDevID, (BYTE)(atoi(szOutVal)))) printf("\nfailed to send channel\n"); 
					else printf("\nchannel sent: %d\n", (BYTE)(atoi(szOutVal)));
					break;
				case 'S': case 's':
					if(!fRunning)
					{
						if(!EX_SetScanType(usDevID, SINGLE_CHAN_DIGIN_SCAN)) printf("\nfailed to set scan type - will use default\n"); 
						if(!EX_Run(usDevID)) printf("\nfailed to start scan run\n"); 
						else
						{ 
							printf("\nScan running. Data being logged to disk file\n\tPress 'E' to end run\n"); fRunning = TRUE; 
							// DEVELOPER NOTE:
							// The following loop is used to simplify the code. There are other things that can be done
							//  during a scan, for example - send digital output or read digital input, change the channel
							//  when in single-channel scan mode, send an analog output, etc.
							while(fRunning)
							{
								if(fEventScan)
								{
									EX_CheckScanStatus(usDevID, &puiNumScansRemainingInBuff, &pfStillScanning, &puiStatusCode);
									if(puiStatusCode & SCAN_COMPLETED)
									{
										printf("Completing scan stop - wait....\n");
										if(!EX_Stop(usDevID)) printf("\nfailed to stop scan run\n"); 
										else
										{ EX_StopComplete(usDevID); printf("\nScan Stopped.\n"); fRunning = FALSE; }
										break;
									}
								}
								if(_kbhit())
								{
									iKeyChar = getch();
									cUserInputVal = (char)iKeyChar;
									if((cUserInputVal == 27) || (cUserInputVal == 'E') || (cUserInputVal == 'e'))
									{
										printf("Completing scan stop - wait....\n");
										if(!EX_Stop(usDevID)) printf("\nfailed to stop scan run\n"); 
										else
										{ EX_StopComplete(usDevID); printf("\nScan Stopped.\n"); fRunning = FALSE; }
										cUserInputVal=0;
										break;
									}
								}
							}
						}
					}
					else printf("Already running - Press 'E' to stop\n"); break;
				case 'E': case 'e':
					if(fRunning)
					{
						if(!EX_Stop(usDevID)) printf("\nfailed to stop scan run\n"); 
						else
						{ EX_StopComplete(usDevID); printf("\nScan Stopped.\n"); fRunning = FALSE; }
					}
					else printf("Already Stopped - Press 'S' to start scan run\n"); break;
				case 'B': case 'b':
					setBeepScreen();
					getBeepOptions();
					break;
				case 'X': case 'x':
					printf("\nEnter digital event to watch for\n"); sprintf(szOutVal, "");
					while(TRUE)
					{
						iKeyChar = getche(); if(iKeyChar == 13) break;
						// take care of backspaces and non-numerics
						if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57)) && (strlen(szOutVal) > 0)) 
						{
							setMainScreen(); if(iKeyChar == 8) szOutVal[strlen(szOutVal)-1] = 0; 
							printf("\nEnter digital event to watch for%s", szOutVal);
							continue;
						}
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff);
					}

					if(!EX_SetScanEndEvent(usDevID, (BYTE)(atoi(szOutVal)), TRUE)){ fEventScan = FALSE; printf("\nfailed to set scan-end event\n"); }
					else { fEventScan = TRUE; printf("\nscan event (digital val) set to: %u\n", (UINT)(atoi(szOutVal))); } 
					sprintf(szOutVal, ""); break;
				case 'N': case 'n':
					printf("\nEnter value\n");
					sprintf(szOutVal, "");
					while(TRUE)
					{
						iKeyChar = getche(); if(iKeyChar == 13) break;
						if((iKeyChar == 8) && (strlen(szOutVal))) 
						{
							setMainScreen();
							szOutVal[strlen(szOutVal)-1] = 0;
							printf("\nEnter value \n%s", szOutVal);
							continue;
						}
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff);
					}
					printf("\ngot: %s\n", szOutVal); break;
			}
		}
		if(!fRedraw) break;
	}

	return 1;
}

void setMainScreen(void)
{
	system("cls");
	printf("\nINITIALIZED\nPress one of the following keys:\n"
		"'Q' quit\n"
		"'R' redraw screen\n"
		"'C' set the channel\n"
		"'S' start scanning\n"
		"'E' end scanning\n"
		"'B' set scan-end BEEP options\n"
		"'X' set scan-end digital event\n"
		);
}

void setBeepScreen(void)
{
	system("cls");
	printf("\nScan-End BEEP option screen\n"
		"'R' Redraw screen\n"
		"'Q' Quit - save results and go back to other screen\n"
		"'C' CANCEL - do not save any entries and to back to other screen\n\n" 
		"'U' use scan-end BEEP (also set if any of the other values are changed)\n"
		"'F' set beep frequency in Hz. (no action or zero sets default of 440Hz)\n"
		"'D' set beep duration in ms.  (no action or zero sets default of 50ms)\n"
		"'I' set beep interval in Hz.  (no action or zero sets default of 2sec)\n"
		"'T' set beep timeout in seconds (no action or zero sets default of 10sec)\n"
		);
}

void getBeepOptions(void)
{
	char cUserInputVal = NULL; char szOutVal[32], szTempBuff[32]; int iKeyChar = 0; 
	sprintf(szOutVal, "");

	BOOLEAN fUseBeep = FALSE; BOOLEAN fRedraw = FALSE;
	// the DLL will use defaults for the following if they are set to zero. That being the case, you only need
	//  to change the ones you actually want to have values that are not defaults. See the header file to
	//  know what the defaults are.
	UINT uiBeepFreq = 0; UINT uiBeepDurationMs = 0; UINT uiBeepIntervalSec = 0; UINT uiBeepTimeoutSec = 0;
	
	while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 'C') && (cUserInputVal != 'c') && (cUserInputVal != 27) && (!fRedraw))
	{
		sprintf(szOutVal, "");
		cUserInputVal = (char)getch();
		switch(cUserInputVal)
		{
			case 'R': case 'r': case 27:
				setBeepScreen(); break;
			case 'Q': case 'q':
				printf("\nQuiting - saving results and going back.\n"); break;
			case 'C': case 'c':
				printf("\nAbandoning changes and going back.\n"); break;
			case 'U': case 'u':
				fUseBeep = TRUE; printf("\nWill use scan-end BEEP.\n"); break;
			case 'F': case 'f':
				system("cls"); printf("\nEnter desired beep frequency. Hit <ENTER> key when done\n");
				fUseBeep = TRUE;

				while(TRUE)
				{
					iKeyChar = getche(); if(iKeyChar == 13) break;
					// take care of backspaces and non-numerics
					if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57)) && (strlen(szOutVal) > 0)) 
					{
						setMainScreen(); szOutVal[strlen(szOutVal)-1] = 0; 
						printf("\nEnter desired beep frequency. Hit <ENTER> key when done \n%s", szOutVal);
						continue;
					}

					sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
					strcat(szOutVal, szTempBuff);
				}
				printf("\ngot: %s\n", szOutVal);
				
				uiBeepFreq = atoi(szOutVal);
				printf("\nFrequency will be set to %u.\nHit any key to return to previous screen", uiBeepFreq);
				while( !_kbhit() ){}
				getch();
				sprintf(szOutVal, "");
				setBeepScreen(); 
				break;
			case 'T': case 't':
				system("cls"); printf("\nEnter desired beep timeout. Hit <ENTER> key when done\n");
				fUseBeep = TRUE;
				while(TRUE)
				{
					iKeyChar = getche(); if(iKeyChar == 13) break;
					// take care of backspaces and non-numerics
					if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57)) && (strlen(szOutVal) > 0)) 
					{
						setMainScreen(); szOutVal[strlen(szOutVal)-1] = 0; 
						printf("\nEnter desired beep timeout. Hit <ENTER> key when done \n%s", szOutVal);
						continue;
					}
					sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
					strcat(szOutVal, szTempBuff);
				}
				printf("\ngot: %s\n", szOutVal);
				
				uiBeepTimeoutSec = atoi(szOutVal);
				printf("\nTimeout will be set to %u.\nHit any key to return to previous screen", uiBeepTimeoutSec);
				while( !_kbhit() ){}
				getch();
				sprintf(szOutVal, "");
				setBeepScreen(); 
				break;
			case 'D': case 'd':
				system("cls"); printf("\nEnter desired beep duration. Hit <ENTER> key when done\n");
				fUseBeep = TRUE;
				while(TRUE)
				{
					iKeyChar = getche(); if(iKeyChar == 13) break;
					// take care of backspaces and non-numerics
					if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57)) && (strlen(szOutVal) > 0)) 
					{
						setMainScreen(); szOutVal[strlen(szOutVal)-1] = 0; 
						printf("\nEnter desired beep duration. Hit <ENTER> key when done \n%s", szOutVal);
						continue;
					}
					sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
					strcat(szOutVal, szTempBuff);
				}
				printf("\ngot: %s\n", szOutVal);
				
				uiBeepDurationMs = atoi(szOutVal);
				printf("\nDuration will be set to %u.\nHit any key to return to previous screen", uiBeepDurationMs);
				while( !_kbhit() ){}
				getch();
				sprintf(szOutVal, "");
				setBeepScreen(); 
				break;
			case 'I': case 'i':
				system("cls"); printf("\nEnter desired beep interval. Hit <ENTER> key when done\n");
				fUseBeep = TRUE;
				while(TRUE)
				{
					iKeyChar = getche(); if(iKeyChar == 13) break;
					// take care of backspaces and non-numerics
					if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57)) && (strlen(szOutVal) > 0)) 
					{
						setMainScreen(); szOutVal[strlen(szOutVal)-1] = 0; 
						printf("\nEnter channel \n%s", szOutVal);
						continue;
					}
					sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
					strcat(szOutVal, szTempBuff);
				}
				printf("\ngot: %s\n", szOutVal);
				
				uiBeepIntervalSec = atoi(szOutVal);
				printf("\nInterval will be set to %u.\nHit any key to return to previous screen", uiBeepIntervalSec);
				while( !_kbhit() ){}
				getch();
				sprintf(szOutVal, "");
				setBeepScreen(); 
				break;
		}
	}

	if(fUseBeep)
	{
		if(!EX_SetRunEndBeepOptions(usDevID, fUseBeep, uiBeepFreq, uiBeepDurationMs, uiBeepIntervalSec, uiBeepTimeoutSec)) 
			printf("\nfailed to set scan-end BEEP option\n");
		else printf("\nBEEP options changed. Hit any key to return to main screen\n");
		while( !_kbhit() ){}
		getch();
	}
	setMainScreen();
}
